<?php
/**
* Permet de charger tout les classes d'un rpertoire
* Utiliser pour que le code coverage contien tous les classes, mme ceux qui ne sont pas charger ou tester
*
* PHP versions 5
* 
* @category  PHP
* @package   Borealis-foundation  
* @author    Pascal Martin 
* @copyright Boral Informations Stratgiques Inc.
* @license   http://www.boreal-is.com/license Borealis License
* @link      http://www.boreal-is.com
*/
 
/**
* Permet de charger tout les classes d'un rpertoire
* Utiliser pour que le code coverage contien tous les classes, mme ceux qui ne sont pas charger ou tester
* 
* @category   PHP 
* @package    Borealis-foundation
* @subpackage Test
* @author     Pascal Martin 
*/
class com_borealis_foundation_test_LoadClass
{
    /**
    * Charge les classes dans le rpertoire spcifier et ces sous-rpertoire
    * 
    * @param string $pstrDirectoryPath      Rpertoire a scanner
    * @param string $pstrClassBaseNameSpace Namespace de base des classe (com_borealis)
    * 
    * @return void
    */
    public static function load($pstrDirectoryPath, $pstrClassBaseNameSpace)
    {
        com_borealis_foundation_util_Assert::assertIsNotEmptyString($pstrDirectoryPath);
       
       
        $objDirIter = new RecursiveDirectoryIterator($pstrDirectoryPath, RecursiveDirectoryIterator::KEY_AS_PATHNAME);
        foreach ($objDirIter as $strFile => $objInfo) 
        {
            if ($objInfo->isFile())
            {   
                $strFile = str_replace('\\', '/', $strFile);         
                $strFileName = basename($strFile);
                
                if (strstr($strFileName, '.php') !== false)
                {
                    $objArrayPath = explode('/', str_replace('.php', '', $strFile));
                    $strClassName = implode('_', $objArrayPath);
                    
                    $strClassName = strstr($strClassName, $pstrClassBaseNameSpace);
                    if ($strClassName !== false)
                    {
                        class_exists($strClassName); // Force l'appel a l'autoload
                    }
                }                
            }
            else if ($objInfo->isDir())
            {
                if (substr($objInfo->getFilename(), 0, 1) != '.')
                {
                    self::load($strFile, $pstrClassBaseNameSpace);                       
                }
            } 
        }    
    }  
}
  
?>
