<?php
/**
* Factory pour la contruction de AuthorizationManagerFactory 
* Retourne un instance de la classe configurer comme manager dans la config
*
* PHP versions 5
* 
* @category  PHP
* @package   Borealis-security  
* @author    Pascal Martin 
* @copyright Boral Informations Stratgiques Inc.
* @license   http://www.boreal-is.com/license Borealis License
* @link      http://www.boreal-is.com
*/
    
/**
* Factory pour la contruction de AuthorizationManagerFactory 
* Retourne un instance de la classe configurer comme manager dans la config
* 
* @category   PHP 
* @package    Borealis-security
* @subpackage Manager
* @author     Pascal Martin
*/
class com_borealis_security_manager_authorization_AuthorizationManagerFactory extends com_borealis_foundation_manager_Factory
{
    /**
    * Return a AuthorizationManager
    * 
    * @throws com_borealis_security_exception_ClassNotFoundException
    * @throws com_borealis_security_exception_BadAuthorizationManagerException 
    * 
    * @return com_borealis_security_manager_authorization_AuthorizationManager
    */
    public static function getAuthorizationManager()
    {
        $objManagerFactory = new com_borealis_security_manager_authorization_AuthorizationManagerFactory(); 
        return $objManagerFactory->getManager(com_borealis_security_SettingImpl::getAuthorizationManager());
    }
   
    /**
    * Vrifie que l'object passer est un instance de com_borealis_security_manager_authorization_AuthorizationManager
    * 
    * @param object $pobjManager object to test
    * 
    * @return bool
    */ 
    protected function isGoodInstance($pobjManager)
    {
        return $pobjManager instanceof com_borealis_security_manager_authorization_AuthorizationManager;  
    }
    
    /**
    * Retourne une erreur
    * 
    * @param string $pstrMessage Message erreur
    * 
    * @return com_borealis_security_exception_BadAuthorizationManagerException
    */
    protected function getError($pstrMessage)
    {
        return new com_borealis_security_exception_BadAuthorizationManagerException($pstrMessage);   
    }
}
    
    
?>