<?php
/**
* Factory pour la contruction de PropertyManager 
* Retourne un instance de la classe configurer comme manager dans la config
*
* PHP versions 5
* 
* @category  PHP
* @package   Borealis-security  
* @author    Pascal Martin 
* @copyright Boral Informations Stratgiques Inc.
* @license   http://www.boreal-is.com/license Borealis License
* @link      http://www.boreal-is.com
*/
    
/**
* Factory pour la contruction de PropertyManager 
* Retourne un instance de la classe configurer comme manager dans la config
* 
* @category   PHP 
* @package    Borealis-security
* @subpackage Manager
* @author     Pascal Martin
*/
class com_borealis_security_manager_property_PropertyManagerFactory extends com_borealis_foundation_manager_Factory
{
    /**
    * Return a PropertyManager
    * 
    * @throws com_borealis_security_exception_ClassNotFoundException
    * @throws com_borealis_security_exception_BadPropertyManagerException 
    * 
    * @return com_borealis_security_manager_property_PropertyManager
    */
    public static function getPropertyManager()
    {
        $objManagerFactory = new com_borealis_security_manager_property_PropertyManagerFactory(); 
        return $objManagerFactory->getManager(com_borealis_security_SettingImpl::getPropertyManager());
    }
    
    /**
    * Vrifie que l'object passer est un instance de com_borealis_security_manager_property_PropertyManager
    * 
    * @param object $pobjManager object to test
    * 
    * @return bool
    */            
    protected function isGoodInstance($pobjManager)
    {
        return $pobjManager instanceof com_borealis_security_manager_property_PropertyManager;  
    }
    
    /**
    * Retourne une erreur
    * 
    * @param string $pstrMessage Message erreur
    * 
    * @return com_borealis_security_exception_BadPropertyManagerException
    */
    protected function getError($pstrMessage)
    {
        return new com_borealis_security_exception_BadPropertyManagerException($pstrMessage);   
    }
}
    
    
?>