<?php
/**
* Classe qui reprsente une proprits
*
* PHP versions 5
* 
* @category  PHP
* @package   Borealis-security  
* @author    Pascal Martin 
* @copyright Boral Informations Stratgiques Inc.
* @license   http://www.boreal-is.com/license Borealis License
* @link      http://www.boreal-is.com
*/

/**
* Classe qui reprsente une proprits
* 
* @category   PHP 
* @package    Borealis-security
* @subpackage User
* @author     Pascal Martin 
*/
class com_borealis_security_user_Property
{
    private $m_strName;
    private $m_strValue;
    
    /**
    * Construit une nouvelle instance de com_borealis_security_user_Property
    * 
    * @param string $pstrName  Nom
    * @param string $pstrValue Valeur
    *
    * @throws com_borealis_security_IllegalArgumentException
    *  
    * @return com_borealis_security_Property
    */
    function __construct($pstrName, $pstrValue) 
    {
        com_borealis_foundation_util_Assert::assertIsNotEmptyString($pstrName);
        com_borealis_foundation_util_Assert::assertIsString($pstrValue); 
        
        $this->m_strName = $pstrName;
        $this->m_strValue = $pstrValue;
    }

    /**
    * Retourne le nom de la proprit
    * 
    * @return string Property name    
    */
    public function getName()
    {
        return $this->m_strName;        
    }
    
    /**
    * Retourne la valeur de la proprit
    * 
    * @return string Property value
    */
    public function getValue()
    {
        return $this->m_strValue;
    }
}   
    
?>