<?php
/**
* Classe qui reprsente un role
*
* PHP versions 5
* 
* @category  PHP
* @package   Borealis-security  
* @author    Pascal Martin 
* @copyright Boral Informations Stratgiques Inc.
* @license   http://www.boreal-is.com/license Borealis License
* @link      http://www.boreal-is.com
*/

/**
* Classe qui reprsente un role
* 
* @category   PHP 
* @package    Borealis-security
* @subpackage User  
* @author     Pascal Martin 
*/
class com_borealis_security_user_Role
{
    private $m_strName;
    
    /**
    * Construit une nouvelle instance de com_borealis_security_user_Role
    * 
    * @param string $pstrName Name
    * 
    * @throws com_borealis_security_IllegalArgumentException
    * 
    * @return com_borealis_security_Role
    */
    function __construct($pstrName) 
    {
        com_borealis_foundation_util_Assert::assertIsNotEmptyString($pstrName);
        
        $this->m_strName = $pstrName;
    }

    /**
    * Retourne le nom de la proprit
    * 
    * @return string Property name    
    */
    public function getName()
    {
        return $this->m_strName;        
    }    
}   
    
?>