<?php
/**
* Classe qui représente un action du acl   
*
* PHP versions 5
* 
* @category  PHP
* @package   Borealis-acl  
* @author    Pascal Martin 
* @copyright 2009, Boreal - Information Strategies
* @license   http://www.boreal-is.com/license BSD License
* @link      http://www.boreal-is.com
*/

/**
* Classe qui représente un action du acl
* 
* @category   PHP 
* @package    Borealis-acl
* @subpackage Object  
* @author     Pascal Martin 
*/ 
class com_borealis_acl_object_Action extends com_borealis_acl_object_Base
{
    /**
    * Create new Action and return
    * 
    * @param string $pstrName Nom de l'action
    * 
    * @return com_borealis_acl_object_Action
    */
    public static function create($pstrName)
    {    
        return parent::create('Action', $pstrName);
    }
    
    /**
    * Return action if exist else null
    * 
    * @param string $pstrName Nom de l'action
    * 
    * @return com_borealis_acl_object_Action
    */
    public static function getByName($pstrName)
    {
        return parent::getByName('Action', $pstrName);               
    }   
    
    /**
    * Return action if exist else null
    * 
    * @param int $piID Indentificateur de l'action
    * 
    * @return com_borealis_acl_object_Action
    */
    public static function getByID($piID)
    {
        return parent::getByID('Action', $piID);        
    } 
    
    /**
    * Return all action
    * 
    * @return ArrayObject of com_borealis_acl_object_Action 
    */
    public static function getAll()
    {
        return parent::getAll('Action');  
    }
   
    // ----------------------------
    // Custom to this object
    // ----------------------------
    
    /**
    * Return list of ressource action
    * 
    * @param com_borealis_acl_object_Ressource $pobjRessource Target Ressource
    * 
    * @return ArrayObject of com_borealis_acl_object_Action
    */
    public static function getRessourceAction(com_borealis_acl_object_Ressource $pobjRessource)
    {
        $objArrayInfos = com_borealis_acl_datastore_DataStoreFactory::getDataStore()->selectRessourceAction($pobjRessource);    
        return self::getArrayObjectFromArrayIDName('Action', $objArrayInfos);    
    }
    
    /**
    * Return list of role permission action
    * 
    * @param com_borealis_acl_object_Role $pobjRole Target Role
    * 
    * @return ArrayObject of com_borealis_acl_object_Action
    */
    public static function getRolePermissionAction(com_borealis_acl_object_Role $pobjRole)
    {
        $objArrayInfos = com_borealis_acl_datastore_DataStoreFactory::getDataStore()->selectRolePermissionAction($pobjRole);    
        return self::getArrayObjectFromArrayIDName('Action', $objArrayInfos);   
    }
}
  
?>
