<?
       
class com_borealis_authentication_checker_LDAPCheckerTest extends PHPUnit_Framework_TestCase
{
    public static function getChecker()
    {
        $strHostname = '192.168.1.39'; 
        $iPort = 389;      
        $strSearchDN = 'ou=People,dc=boreal-is,dc=com';  
        $strUsernameColumn = 'uid';        
        $objArrayOptions = array(LDAP_OPT_PROTOCOL_VERSION => 3); 

        return new com_borealis_authentication_checker_LdapChecker(new com_borealis_authentication_password_RawPasswordCreator(), $strHostname, $iPort, $strSearchDN, $strUsernameColumn, $objArrayOptions) ;          
    }
    
    /**
    * @author Pascal Martin
    * @test
    */
    public function testConstruct()
    {
        $objChecker = self::getChecker();
        $this->assertTrue( $objChecker instanceof com_borealis_authentication_checker_Checker);
    }
       
    /**
    * @author Pascal Martin
    * @test
    */
    public function testIsAuthorized()
    {
        $objChecker = self::getChecker();
        $bAuthorized = $objChecker->isAuthorized('authuser', 'Z!33iLi42');
        $this->assertTrue($bAuthorized);
    }
    
    /**
    * @author Pascal Martin
    * @test
    */
    public function testIsAuthorized2()
    {
        $objChecker = self::getChecker();
        $bAuthorized = $objChecker->isAuthorized('admin', 'adminasdasdas');
        $this->assertFalse($bAuthorized);
    }
    
    /**
    * @expectedException com_borealis_foundation_exception_AssertException 
    * @author Pascal Martin
    * @test
    */
    public function testIsAuthorized3()
    {
        $objChecker = self::getChecker();
        $bAuthorized = $objChecker->isAuthorized('', 'adminasdasdas');
    }
    
    /**
    * @expectedException com_borealis_foundation_exception_AssertException 
    * @author Pascal Martin
    * @test
    */
    public function testIsAuthorized4()
    {
        $objChecker = self::getChecker();
        $bAuthorized = $objChecker->isAuthorized('sdfds', '');
    }
    
    /**
    * @expectedException com_borealis_foundation_exception_AssertException 
    * @author Pascal Martin
    * @test
    */
    public function testIsAuthorized5()
    {
        $objChecker = self::getChecker();
        $bAuthorized = $objChecker->isAuthorized('sdfds', 456);
    }
    
    /**  
    * @expectedException Exception
    * @author Pascal Martin
    * @test
    */
    public function testIsAuthorized6()
    {
        $strHostname = 'tomate789'; 
        $iPort = 389;      
        $strSearchDN = 'ou=People,dc=boreal-is,dc=com';  
        $strUsernameColumn = 'uid';        
        $objArrayOptions = array(LDAP_OPT_PROTOCOL_VERSION => 3); 

        $objChecker = new com_borealis_authentication_checker_LdapChecker(new com_borealis_authentication_password_RawPasswordCreator(), $strHostname, $iPort, $strSearchDN, $strUsernameColumn, $objArrayOptions) ;          

        $bAuthorized = $objChecker->isAuthorized('sdfds', 'asdad');
    }
    
    /**
    * @expectedException Exception
    * @author Pascal Martin
    * @test
    */
    public function testIsAuthorized7()
    {
        $strHostname = '192.168.1.39'; 
        $iPort = 389;      
        $strSearchDN = 'ou=People,dc=boreal-is,dc=com';  
        $strUsernameColumn = '';        
        $objArrayOptions = array(LDAP_OPT_PROTOCOL_VERSION => 3); 

        $objChecker = new com_borealis_authentication_checker_LdapChecker(new com_borealis_authentication_password_RawPasswordCreator(), $strHostname, $iPort, $strSearchDN, $strUsernameColumn, $objArrayOptions) ;          

        $bAuthorized = $objChecker->isAuthorized('sdfds', 'asdad');
    }   
}   
    
?>