<?php
/**
* Method utilitaire pour l'encodage UTF-8  
*
* PHP versions 5
* 
* @category  PHP
* @package   Borealis-foundation  
* @author    Frederick Deslandes 
* @copyright 2009, Boreal - Information Strategies
* @license   http://www.boreal-is.com/license BSD License
* @link      http://www.boreal-is.com
*/
 
/**
* Method utilitaire pour l'encodage UTF-8   
* 
* @category   PHP 
* @package    Borealis-foundation
* @subpackage Util
* @author     Frederick Deslandes 
*/ 
class com_borealis_foundation_util_Encoding
{
    /**
    * Function found on php.net used to transform an url-encoded string into utf-8.
    * 
    * @param mixed $pobjUrlPart url encoded utf-8 string or array of strings to decode
    * 
    * @return mixed Array of string or string, depending on parameter type
    */
    public static function Utf8_urldecode($pobjUrlPart) 
    {
        $objReturn = null;
        
        if (is_array($pobjUrlPart))
        {
            $objReturn = array();
            
            foreach ($pobjUrlPart as $strUrlPart)
            {
                $strUrlPart = preg_replace("/%u([0-9a-f]{3,4})/i", "&#x\\1;", urldecode($strUrlPart));
                array_push($objReturn, html_entity_decode($strUrlPart, null, 'UTF-8')); 
            }
        }
        else
        {
            $pobjUrlPart = preg_replace("/%u([0-9a-f]{3,4})/i", "&#x\\1;", urldecode($pobjUrlPart));
            $objReturn = html_entity_decode($pobjUrlPart, null, 'UTF-8');
        }
        
        return $objReturn;        
    }
    
    /**
    * From php.net site, do file_get_contents and convert the result in utf-8
    * 
    * @param String $pstrFilePath File path
    * 
    * @return string
    */
    public static function File_get_contents_utf8($pstrFilePath) 
    {
        $strContent = file_get_contents($pstrFilePath);
        return mb_convert_encoding($strContent, 'UTF-8', mb_detect_encoding($strContent, 'UTF-8, ISO-8859-1', true));
    }
    
    /**
    * do fgets and convert the result in utf-8
    * 
    * @param resource &$pobjHandle File path
    * @param int      $piLength    length in bytes
    * 
    * @return string
    */
    public static function Fgets_utf8(&$pobjHandle, $piLength = null) 
    {
        $strLine = null;
        
        if (is_null($piLength))
        {
            $strLine = fgets($pobjHandle);
        }
        else
        {
            $strLine = fgets($pobjHandle, $piLength);
        }
            
        return mb_convert_encoding($strLine, 'UTF-8', mb_detect_encoding($strLine, 'UTF-8, ISO-8859-1', true));
    }
}
 
?>
