<?php

session_start();

// -----------------------------------------------
// --- Step 1 : Mettre la source de borealis-authentication et borealis-foundation disponible dans le classe path
// -----------------------------------------------

$strCurrentDir = dirname(__FILE__);   
$strgeoprismaRoot = "$strCurrentDir/../.."; 
$strBorealisFoundation = "$strgeoprismaRoot/lib/borealis-foundation-0.1.0.0";
$strBorealisAuthentication = "$strgeoprismaRoot/lib/php-borealis-authentication-0.1.0.2-lite"; 
set_include_path(".".PATH_SEPARATOR.$strBorealisFoundation.
					 PATH_SEPARATOR.$strBorealisAuthentication);

// -----------------------------------------------
// --- Step 2 : Inclure la classe responsable du chargement des autre classe (com/borealis/Autoload)
// -----------------------------------------------
require_once 'com/borealis/Autoload.php';

/*
require_once 'com/borealis/authentication/password/PasswordCreator.php';
require_once 'com/borealis/authentication/password/RawPasswordCreator.php';
require_once 'com/borealis/authentication/password/MD5PasswordCreator.php';
require_once 'com/borealis/authentication/checker/Checker.php';
require_once 'com/borealis/authentication/checker/JossoChecker.php';
*/

if(isset($_REQUEST['logout']))
{
    unset($_SESSION['login_username']);
}

if (!isset($_SESSION['login_username']))
{
    $strUsername = null;
    $strPassword = null;
    $strMethod = null;
    $strError = '';
    
    if(isset($_REQUEST['username']))
    {
        $strUsername = $_REQUEST['username'];
    }
    if(isset($_REQUEST['password']))
    {
        $strPassword = $_REQUEST['password'];
    }
    if(isset($_REQUEST['method']))
    {
        $strMethod = $_REQUEST['method'];
    }

    if ($strUsername == null || $strPassword == null || $strMethod == null)
    {
        if(!isset($_REQUEST['logout']) && $strMethod != null)
        {
            $strError = 'Username and password are mandatory';
        }         
        include 'login.php';
        exit;
    }
    
    // -----------------------------------------------
    // --- Step 3 : Configurer la library borealis-authentication, l'ui indiquer la liste des checher (Serveur d'authentification ou méthode d'authentification)
    // -----------------------------------------------

    // ---- Constructeur de Password (Password = class qui encode le mot de passe dans le bon format)
    // ----
    // Createur de mot de passe en texte claire
    $objRawPasswordCreator = new com_borealis_authentication_password_RawPasswordCreator();

    // Créateur de mot de passe qui encode le mot de passe en md5
    $objMD5PasswordCreator = new com_borealis_authentication_password_MD5PasswordCreator();

    // ---- Checker (Serveur d'authentification ou méthode d'authentification)
    // ----
    $objChecker = null;
    switch($strMethod)
    {
        case 'josso':
            // Checker qui vérifie les droits de connexion par un serveur JOSSO
            $g_strJossoUrl = 'http://192.168.3.204:9998/josso/services/SSOIdentityProvider?wsdl';
            $g_strJossoSecurityDomain = 'josso';
            $objChecker = new com_borealis_authentication_checker_JossoChecker($objRawPasswordCreator, $g_strJossoUrl, $g_strJossoSecurityDomain);
            break;
        case 'ldap':
            // Checker qui vérifie les droits de connexion par un serveur LDAP
            $g_strLDAPHostname = '192.168.1.39';
            $g_iLDAPPort = 389;
            $g_strLDAPSearchDN = 'ou=People,dc=boreal-is,dc=com';
            $g_strLDAPUsernameColumn = 'uid';
            $g_strLDAPArrayOptions = array(LDAP_OPT_PROTOCOL_VERSION => 3);
            $objChecker = new com_borealis_authentication_checker_LdapChecker($objRawPasswordCreator, $g_strLDAPHostname, $g_iLDAPPort, $g_strLDAPSearchDN, $g_strLDAPUsernameColumn, $g_strLDAPArrayOptions) ;
            break;
        case 'pdo':
            // Checker qui vérifie les droits de connexion par une BD
            $g_strPDODSN = 'pgsql:host=192.168.3.204;port=5433;dbname=geoprisma;user=postgres;password=postgres';
            $g_strPDOQuery = 'select id from users where username = :username and password = :password';
            $objChecker = new com_borealis_authentication_checker_PDOChecker($objMD5PasswordCreator, $g_strPDODSN, $g_strPDOQuery);
            break;
        case 'xml_1':
            // Checker qui vérifie les droits de connexion par un fichier XML
            $g_strXMLFILE = dirname(__FILE__).'/users.xml';
            $objChecker = new com_borealis_authentication_checker_XMLChecker($objRawPasswordCreator, $g_strXMLFILE);
            break;
        case 'xml_2':
            // Checker qui vérifie les droits de connexion par un fichier XML
            $g_strXMLFILE = dirname(__FILE__).'/users.xml';
            $objChecker = new com_borealis_authentication_checker_XMLChecker($objMD5PasswordCreator, $g_strXMLFILE);
            break;
    }
    
    // ---- com_borealis_authentication_SettingImpl setCheckers (Permet d'indiquer la liste des Checker qui serons utiliser par le com_borealis_authentication_AuthenticationManager)
    // ----
    com_borealis_authentication_SettingImpl::setCheckers(array($objChecker));

    // -----------------------------------------------
    // --- Step 4 : Test if user is authorized to login
    // -----------------------------------------------
    $bIsAuthorized = com_borealis_authentication_AuthenticationManager::isAuthorized($strUsername, $strPassword);
    if ($bIsAuthorized)
    {        
        $_SESSION['login_username'] = $strUsername;
    }
    else
    {
        $strError = 'Bad username or password';
        include 'login.php';
        exit;
    }
}

?>