<?xml version="1.0" encoding="utf-8"?>
<xsl:stylesheet version="1.0" xmlns:php="http://php.net/xsl"
    xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
    xmlns:dyn="http://exslt.org/dynamic"
    xmlns:html="http://www.w3.org/1999/xhtml"
    xmlns:map="http://geoprisma.org/map"
    xmlns:mapfishlayertree="http://geoprisma.org/mapfishlayertree"
    xmlns:htwindow="http://geoprisma.org/htwindow"
    xmlns:measuretool="http://geoprisma.org/measuretool"
    xmlns:queryonclick="http://geoprisma.org/queryonclick"
    xmlns:resultextgrid="http://geoprisma.org/resultextgrid"
    xmlns:initialview="http://geoprisma.org/initialview"
    xmlns:zoomslider="http://geoprisma.org/zoomslider"
    xmlns:mouseposition="http://geoprisma.org/mouseposition"
    xmlns:getmouseposition="http://geoprisma.org/getmouseposition"
    xmlns:scale="http://geoprisma.org/scale"
    xmlns:editfeature_create="http://geoprisma.org/editfeature_create"
    xmlns:editfeature_update="http://geoprisma.org/editfeature_update"
    xmlns:editfeature_delete="http://geoprisma.org/editfeature_delete"
    xmlns:featurepanel_form="http://geoprisma.org/featurepanel_form"
    xmlns:featurepanel_selector="http://geoprisma.org/featurepanel_selector"
    xmlns:geoexttoolbar="http://geoprisma.org/geoexttoolbar"
    xmlns:shortcut="http://geoprisma.org/shortcut"
    xmlns:geoextux_geonamessearchcombo="http://geoprisma.org/geoextux_geonamessearchcombo"
    xmlns:geoextux_redliningpanel="http://geoprisma.org/geoextux_redliningpanel"
    xmlns:geoextux_shortcutcombo="http://geoprisma.org/geoextux_shortcutcombo"
    xmlns:geoextux_zoomto="http://geoprisma.org/geoextux_zoomto"
    xmlns:geoextux_wmsbrowser="http://geoprisma.org/geoextux_wmsbrowser"
    xmlns:unselectall="http://geoprisma.org/unselectall"
    xmlns:geoextprintform="http://geoprisma.org/geoextprintform"
    xmlns:filetreepanel="http://geoprisma.org/filetreepanel"
    xmlns:geoextux_layertreebuilder="http://geoprisma.org/geoextux_layertreebuilder"
    xmlns:mappanel="http://geoprisma.org/mappanel"
    xmlns:layer="http://geoprisma.org/layer"
    xmlns:pdfprint="http://geoprisma.org/pdfprint"
    xmlns:querybyrect="http://geoprisma.org/querybyrect"
    xmlns:featurepanel_attributeform="http://geoprisma.org/featurepanel_attributeform"
    xmlns:featurepanel_customform="http://geoprisma.org/featurepanel_customform"
    xmlns:vectorlayer="http://geoprisma.org/vectorlayer"
    xmlns:resultvectorlayer="http://geoprisma.org/resultvectorlayer"
    xmlns:queryonclickwizard="http://geoprisma.org/queryonclickwizard"
    xmlns:attributefilterpanel="http://geoprisma.org/attributefilterpanel"
    xmlns:geoextux_printpreview="http://geoprisma.org/geoextux_printpreview"
    xmlns:wfsfilterbuilder="http://geoprisma.org/wfsfilterbuilder"
    xmlns:templatepopup="http://geoprisma.org/templatepopup"
    xmlns:toggle="http://geoprisma.org/toggle"
    xmlns:editfeature_split="http://geoprisma.org/editfeature_split"
    xmlns:editfeature_drag="http://geoprisma.org/editfeature_drag"
    xmlns:editfeature_copy="http://geoprisma.org/editfeature_copy"
    xmlns:editfeature_confirm="http://geoprisma.org/editfeature_confirm"
    xmlns:keepactivesession="http://geoprisma.org/keepactivesession"
    xmlns:api="http://geoprisma.org/api"
    xmlns:applyfilter="http://geoprisma.org/applyfilter"

    extension-element-prefixes="dyn map mapfishlayertree htwindow measuretool queryonclick resultextgrid initialview zoomslider mouseposition getmouseposition scale editfeature_create editfeature_update editfeature_delete featurepanel_form featurepanel_selector geoexttoolbar shortcut geoextux_geonamessearchcombo geoextux_redliningpanel geoextux_shortcutcombo geoextux_zoomto geoextux_wmsbrowser unselectall filetreepanel geoextux_layertreebuilder mappanel layer pdfprint querybyrect featurepanel_attributeform featurepanel_customform vectorlayer resultvectorlayer queryonclickwizard attributefilterpanel geoextux_printpreview wfsfilterbuilder templatepopup toggle editfeature_split editfeature_drag editfeature_copy editfeature_confirm keepactivesession api applyfilter">

  <xsl:output method="html" indent="yes" encoding="utf-8" omit-xml-declaration="yes"/>
  <xsl:namespace-alias stylesheet-prefix="php" result-prefix="xsl" />

  <xsl:include href="inc/Globals.xslt" />

  <xsl:include href="../widgets/map/Map.xslt" />
  <xsl:include href="../widgets/mapfishlayertree/MapFishLayerTree.xslt"/>
  <xsl:include href="../widgets/htwindow/HTWindow.xslt"/>
  <xsl:include href="../widgets/measuretool/MeasureTool.xslt" />
  <xsl:include href="../widgets/queryonclick/QueryOnClick.xslt" />
  <xsl:include href="../widgets/attributefilterpanel/AttributeFilterPanel.xslt"/>
  <xsl:include href="../widgets/resultextgrid/ResultExtGrid.xslt" />
  <xsl:include href="../widgets/initialview/InitialView.xslt" />
  <xsl:include href="../widgets/zoomslider/ZoomSlider.xslt" />
  <xsl:include href="../widgets/mouseposition/MousePosition.xslt" />
  <xsl:include href="../widgets/getmouseposition/GetMousePosition.xslt" />
  <xsl:include href="../widgets/scale/Scale.xslt"/>
  <xsl:include href="../widgets/editfeature/create/Create.xslt" />
  <xsl:include href="../widgets/editfeature/update/Update.xslt" />
  <xsl:include href="../widgets/editfeature/delete/Delete.xslt" />
  <xsl:include href="../widgets/featurepanel/form/Form.xslt" />
  <xsl:include href="../widgets/featurepanel/selector/Selector.xslt" />
  <xsl:include href="../widgets/geoexttoolbar/GeoExtToolbar.xslt" />
  <xsl:include href="../widgets/shortcut/Shortcut.xslt" />
  <xsl:include href="../widgets/geoextux/geonamessearchcombo/GeoNamesSearchCombo.xslt" />
  <xsl:include href="../widgets/geoextux/redliningpanel/RedLiningPanel.xslt" />
  <xsl:include href="../widgets/geoextux/shortcutcombo/ShortcutCombo.xslt" />
  <xsl:include href="../widgets/geoextux/zoomto/ZoomTo.xslt" />
  <xsl:include href="../widgets/geoextux/wmsbrowser/WMSBrowser.xslt" />
  <xsl:include href="../widgets/unselectall/UnselectAll.xslt" />
  <xsl:include href="../widgets/geoextprintform/GeoExtPrintForm.xslt" />
  <xsl:include href="../widgets/filetreepanel/FileTreePanel.xslt"/>
  <xsl:include href="../widgets/geoextux/layertreebuilder/LayerTreeBuilder.xslt" />
  <xsl:include href="../widgets/mappanel/MapPanel.xslt"/>
  <xsl:include href="../widgets/layer/Layer.xslt"/>
  <xsl:include href="../widgets/pdfprint/PDFPrint.xslt" />
  <xsl:include href="../widgets/querybyrect/QueryByRect.xslt" />
  <xsl:include href="../widgets/featurepanel/attributeform/AttributeForm.xslt" />
  <xsl:include href="../widgets/featurepanel/customform/CustomForm.xslt" />
  <xsl:include href="../widgets/vectorlayer/VectorLayer.xslt" />
  <xsl:include href="../widgets/resultvectorlayer/ResultVectorLayer.xslt" />
  <xsl:include href="../widgets/queryonclickwizard/QueryOnClickWizard.xslt" />
  <xsl:include href="../widgets/geoextux/printpreview/PrintPreview.xslt" />
  <xsl:include href="../widgets/wfsfilterbuilder/WFSFilterBuilder.xslt" />
  <xsl:include href="../widgets/templatepopup/TemplatePopup.xslt" />
  <xsl:include href="../widgets/toggle/Toggle.xslt" />
  <xsl:include href="../widgets/editfeature/split/Split.xslt" />
  <xsl:include href="../widgets/editfeature/drag/Drag.xslt" />
  <xsl:include href="../widgets/editfeature/copy/Copy.xslt" />
  <xsl:include href="../widgets/editfeature/confirm/Confirm.xslt" />
  <xsl:include href="../widgets/keepactivesession/KeepActiveSession.xslt" />
  <xsl:include href="../widgets/api/API.xslt" />
  <xsl:include href="../widgets/applyfilter/ApplyFilter.xslt" />

  <xsl:template match="*">

    <!-- MapPanel+Layer widgets OR Map widget detection  START -->
    <xsl:variable name="bOneMapPanel">
      <xsl:value-of select="count(/geoprisma/widgets/widget[./type = 'mappanel']) = 1"></xsl:value-of>
    </xsl:variable>
    <xsl:variable name="bOneMap">
      <xsl:value-of select="count(/geoprisma/widgets/widget[./type = 'map']) = 1"></xsl:value-of>
    </xsl:variable>

    <xsl:variable name="strMapName">
      <xsl:choose>
        <xsl:when test="$bOneMapPanel = 'true'">
          <xsl:value-of select="/geoprisma/widgets/widget[./type = 'mappanel']/name" />
        </xsl:when>
        <xsl:when test="$bOneMap = 'true'">
          <xsl:value-of select="/geoprisma/widgets/widget[./type = 'map']/name" />
        </xsl:when>
        <xsl:otherwise>false</xsl:otherwise>
      </xsl:choose>
    </xsl:variable>
    <!-- MapPanel+Layer widgets OR Map widget detection  END -->

    <!-- DOCTYPE -->
    <xsl:text disable-output-escaping='yes'>&lt;!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd"></xsl:text>
    <html xmlns="http://www.w3.org/1999/xhtml">
      <head>
        <meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
        <xsl:call-template name="mappanel:printPageTitle" />
      </head>
      <body>

        <!-- no map, no need to do anything -->
        <xsl:if test="$strMapName = 'false'">
          <div>
            <center>
              <br /><br />
              <h1>Error : No or more than one maps detected.</h1>
            </center>
          </div>
        </xsl:if>

        <!-- map found, proceed -->
        <xsl:if test="not($strMapName = 'false')">
          <div id="map" />

          <xsl:if test="not($g_ex_viewport)">
            <!-- header -->
            <xsl:variable name="headerFile">
              <xsl:value-of select="php:functionString('getSampleHeader')"></xsl:value-of>
            </xsl:variable>
            <xsl:copy-of select="document($headerFile)" />
            
            <div id="sampleContent"></div>

            <!-- footer -->
            <xsl:variable name="footerFile">
              <xsl:value-of select="php:functionString('getSampleFooter')"></xsl:value-of>
            </xsl:variable>
            <xsl:copy-of select="document($footerFile)" />
          </xsl:if>
            
          <!-- ****************** -->   
          <!-- Stylesheet Include -->
          <!-- ****************** -->    
          <link rel="stylesheet" type="text/css">
            <xsl:attribute name="href" >
              <xsl:value-of select="$g_lib_url"/>
              <xsl:text>/ext/resources/css/ext-all.css</xsl:text>
            </xsl:attribute>
          </link>
          <!-- openlayers example stylesheet, for sample only -->
          <link rel="stylesheet" type="text/css">
            <xsl:attribute name="href" >
              <xsl:value-of select="$g_lib_url"/>
              <xsl:text>/openlayers/examples/style.css</xsl:text>
            </xsl:attribute>
          </link>
          <!-- include sample styleheet, if any... -->
          <link rel="stylesheet" type="text/css" href="style.css"></link>
          <!--
             When MapPanel is not drawn in a viewport, the map div doesn't 
             take the toolbar height in consideration, so a little hack to
             the OpenLayers styling is necessary.
            -->
          <style type="text/css">
            .olControlScale {
              bottom: 7em;
            }
          </style>
                
          <!-- ************* -->
          <!-- ExtJs Include -->
          <!-- ************* -->
          <script type="text/javascript">
            <xsl:attribute name="src" >
              <xsl:value-of select="$g_lib_url"/>
                <xsl:choose>
                <xsl:when test="$g_ex_ext_debug">
                  <xsl:text>/ext/adapter/ext/ext-base-debug.js</xsl:text> 
                </xsl:when>
                <xsl:otherwise>
                  <xsl:text>/ext/adapter/ext/ext-base.js</xsl:text>
                </xsl:otherwise>
              </xsl:choose>
            </xsl:attribute>
          </script>
          <script type="text/javascript">
            <xsl:attribute name="src" >
              <xsl:value-of select="$g_lib_url"/>
              <xsl:choose>
                <xsl:when test="$g_ex_ext_debug">
                  <xsl:text>/ext/ext-all-debug.js</xsl:text> 
                </xsl:when>
                <xsl:otherwise>
                  <xsl:text>/ext/ext-all.js</xsl:text>
                </xsl:otherwise>
              </xsl:choose>
            </xsl:attribute>
          </script>
          <script type="text/javascript">
            <xsl:attribute name="src" >
              <xsl:value-of select="$g_lib_url"/> 
              <xsl:text>/ext/src/locale</xsl:text>                         
              <!-- ext-lang-en.js | ext-lang-fr_CA.js | ext-lang-fa.js -->                          
              <xsl:choose>
                <xsl:when test="$g_locale = 'en_US'">
                  <xsl:text>/ext-lang-en.js</xsl:text>  
                </xsl:when>
                <xsl:when test="$g_locale = 'fr_CA'">
                  <xsl:text>/ext-lang-fr_CA.js</xsl:text>  
                </xsl:when>
                <xsl:when test="$g_locale = 'fa_AF'">
                  <xsl:text>/ext-lang-fa.js</xsl:text>
                </xsl:when>
                <xsl:otherwise>
                  <xsl:text>/ext-lang-en.js</xsl:text>  
                </xsl:otherwise>
              </xsl:choose>
            </xsl:attribute>
          </script>    

          <!-- ****************** -->   
          <!-- printAllLibSources -->
          <!-- ****************** -->

          <xsl:variable name="libVersion">
            <xsl:choose>
              <xsl:when test="count(/geoprisma/widgets/widget[./type = 'map']) != 0">deprecated</xsl:when>
              <xsl:when test="count(/geoprisma/widgets/widget[./type = 'mapfishlayertree']) != 0">deprecated</xsl:when>
              <xsl:when test="count(/geoprisma/widgets/widget[./type = 'mapfishrecenter']) != 0">deprecated</xsl:when>
              <xsl:otherwise>stable</xsl:otherwise>
            </xsl:choose>
          </xsl:variable>

          <xsl:call-template name="printAllLibSources" >
            <xsl:with-param name="pVersion">
              <xsl:value-of select="$libVersion" />
            </xsl:with-param>
            <xsl:with-param name="pCompressed">
              <xsl:value-of select="$g_ex_compressed_lib" />
            </xsl:with-param>
          </xsl:call-template>

          <!-- ************************** -->
          <!-- Sample JavaScript includes -->
          <!-- ************************** -->
          <xsl:variable name="sampleFile">
            <xsl:value-of select="php:functionString('getSampleFile')"></xsl:value-of>
          </xsl:variable>
          <xsl:copy-of select="document($sampleFile)" />
                
          <!-- Widget source and execution code -->
          <xsl:call-template name="printAllWidgetSources" />
          <xsl:call-template name="printAllWidgetExecutions" >
            <xsl:with-param name="pMapName">
              <xsl:value-of select="$strMapName"></xsl:value-of>
            </xsl:with-param>
          </xsl:call-template>

          <!-- viewport  -->

          <script type="text/javascript">
            
            var aoViewportItemsToAdd = [];
            var aoViewportItems = [];
            var oWestPanel, oSouthPanel, oCenterPanel, oEastPanel;

            Ext.onReady(function() {
                oCenterPanel = new Ext.Panel({
                    region: 'center',
                    deferredRender:false,
                    activeTab: 0,
                    plain:true,
                    layout: 'fit',
                    layoutOnTabChange: true,
                    border: true,
                    id: 'center-panel'
                });
                aoViewportItemsToAdd.push(oCenterPanel);

                <xsl:if test="$bOneMapPanel = 'true'">
                  <xsl:call-template name="mappanel:drawWidgets">
                    <xsl:with-param name="pContainer">
                      <xsl:text>oCenterPanel</xsl:text>
                    </xsl:with-param>
                  </xsl:call-template>
                </xsl:if>
                <xsl:if test="$bOneMap = 'true'">
                    var oMapPanel = new GeoExt.MapPanel({                    
                        id: 'gpDefaultMap',
                        xtype: 'gx_mappanel',
                        title: 'Map',
                        region: 'center',
                        border: false,
                        <xsl:if test="count(/geoprisma/widgets/widget[./type = 'geoexttoolbar']) > 0 ">
                            <xsl:call-template name="geoexttoolbar:drawWidgets"/>
                        </xsl:if>  
                        map: oMap

			<xsl:if test="count(/geoprisma/widgets/widget[./type = 'zoomslider']) > 0 ">
			  ,  items: [<xsl:for-each select="/geoprisma/widgets/widget[./type = 'zoomslider']">
                            <xsl:call-template name="zoomslider:drawWidget">
                              <xsl:with-param name="pWidgetName" select="./name" />
                            </xsl:call-template>
                          </xsl:for-each>]
			</xsl:if>
                    });
                    oCenterPanel.add(oMapPanel);
                    map = oMap;
                </xsl:if>

                oSouthPanel = new Ext.Panel({
                    region: 'south',
                    id: 'south-panel',
                    split: true,
                    height: 190,
                    minSize: 160,
                    maxSize: 300,
                    collapsible: true,
                    collapsed: true,
                    forceLayout: true,
                    animCollapse: false,
                    title: 'Information',
                    margins: '0 0 0 0',
                    layout: 'fit'
                });
                aoViewportItemsToAdd.push(oSouthPanel);

                <xsl:for-each select="/geoprisma/widgets/widget[./type = 'resultextgrid']">
                  <xsl:if test="./options/inwindow = 'false'"> 
                    oSouthPanel.add(
                    <xsl:call-template name="resultextgrid:drawWidget">
                      <xsl:with-param name="pWidgetName" select="./name" />
                    </xsl:call-template>);
                  </xsl:if>  
                </xsl:for-each>

                <!-- ApplyFilter -->
                <xsl:call-template name="applyfilter:drawWidgets">
                  <xsl:with-param name="pContainer">
                    <xsl:text>oSouthPanel</xsl:text>
                  </xsl:with-param>
                </xsl:call-template>

                <!-- FeaturePanel_Selector START -->
                var oFeaturePanelSelectorWindow = new Ext.Window({
                    xtype: 'panel',
                    id: 'FeaturePanelSelectorWindow',
                    width: 800,
                    height: 500,
                    margins: '0 0 0 5',
                    layout: 'fit',
                    closeAction: 'hide'
                });
                <xsl:call-template name="featurepanel_selector:drawWidgets">
                  <xsl:with-param name="pContainer">
                    <xsl:text>oFeaturePanelSelectorWindow</xsl:text>
                  </xsl:with-param>
                </xsl:call-template>
                oFeaturePanelSelectorWindow.render(Ext.getBody());
                <!-- FeaturePanel_Selector END -->

                oWestPanel = new Ext.Panel({
                    region: 'west',
                    id: 'west-panel',
                    title: 'Menu',
                    split: true,
                    width: 200,
                    minSize: 175,
                    maxSize: 400,
                    collapsible: true,
                    margins: '0 0 0 5',
                    layout: 'accordion',
                    layoutConfig:{animate: true}
                });
                aoViewportItemsToAdd.push(oWestPanel);

                <xsl:call-template name="geoextux_layertreebuilder:drawWidgets">
                  <xsl:with-param name="pContainer">
                    <xsl:text>oWestPanel</xsl:text>
                  </xsl:with-param>
                </xsl:call-template>

                <xsl:for-each select="/geoprisma/widgets/widget[./type = 'mapfishlayertree']">
                  oWestPanel.add(
                  <xsl:call-template name="mapfishlayertree:drawWidget">
                    <xsl:with-param name="pWidgetName" select="./name" />
                  </xsl:call-template>);
                </xsl:for-each>

                <xsl:call-template name="geoextprintform:drawWidgets">
                  <xsl:with-param name="pContainer">
                    <xsl:text>oWestPanel</xsl:text>
                  </xsl:with-param>
                </xsl:call-template>

                <xsl:call-template name="filetreepanel:drawWidgets">
                  <xsl:with-param name="pContainer">
                    <xsl:text>oWestPanel</xsl:text>
                  </xsl:with-param>
                </xsl:call-template>


                oEastPanel = new Ext.Panel({
                    region: 'east',
                    id: 'east-panel',
                    title: 'Other widgets',
                    split: true,
                    width: 230,
                    minSize: 175,
                    maxSize: 400,
                    collapsible: true,
                    margins: '0 0 0 5',
                    layout: 'accordion',
                    layoutConfig:{animate: true}
                });
                aoViewportItemsToAdd.push(oEastPanel);

                <xsl:for-each select="/geoprisma/widgets/widget[./type = 'attributefilterpanel']">
                    oEastPanel.add(
                        <xsl:call-template name="attributefilterpanel:drawWidget">
                            <xsl:with-param name="pWidgetName" select="./name" />
                        </xsl:call-template>
                    );
                </xsl:for-each>

                <!-- Shortcut widgets, only added if not in geoexttoolbar -->
                <xsl:variable name="shortcutInToolbar">
                <xsl:for-each select="/geoprisma/widgets/widget[./type = 'geoexttoolbar']/options/widgets/widget">
                  <xsl:variable name="shortcutWidget">
                    <xsl:value-of select="." />
                  </xsl:variable>
                  <xsl:if test="/geoprisma/widgets/widget[./type = 'shortcut']/name = $shortcutWidget">1</xsl:if>
                  </xsl:for-each>
                </xsl:variable>
                <xsl:if test="$shortcutInToolbar = ''">
                  <xsl:call-template name="shortcut:drawWidgets">
                    <xsl:with-param name="pContainer">
                      <xsl:text>oEastPanel</xsl:text>
                    </xsl:with-param>
                  </xsl:call-template>
                </xsl:if>

                <!-- VIEWPORT -->
                for(var i=0, len=aoViewportItemsToAdd.length; i&lt;len; i++){
                    var oItem = aoViewportItemsToAdd[i];
                    if(oItem.items &amp;&amp; oItem.items.length &gt; 0) {
                        aoViewportItems.push(oItem);
                    }
                }

              <xsl:choose>
                <xsl:when test="$g_ex_viewport">
                viewport = new Ext.Viewport({
                    border: false,
                    layout: 'border',
                    items: aoViewportItems
                });
                </xsl:when>
                <xsl:otherwise>
                viewport = new Ext.Panel({
                    border: false,
                    layout: 'border',
                    items: aoViewportItems,
                    width: 800,
                    height: 600,
                    renderTo: Ext.get('sampleContent')
                });
                </xsl:otherwise>
              </xsl:choose>

              <!-- initial map center -->
              !map.center &amp;&amp; map.zoomToMaxExtent();
            });
          </script>


        </xsl:if> <!-- if strMapName != false -->
      </body>
    </html>
  </xsl:template>
</xsl:stylesheet>
