<?php
/* 
   Copyright (c) 2009-2012 Mapgears
   Published under the BSD license.
   See http://geoprisma.org/license for the full text of the license. 
*/ 

class ApplyFilter extends org_geoprisma_widget_WidgetBase
{
    static public function getText($pstrMsg, $pstrType = null)
    {
        return parent::getText($pstrMsg, self::getType(), $pstrType);
    }
  
    static public function getAction()
    {
        return 'read';
    }    
    
    static public function getType()
    {
        return 'applyfilter';
    }

    static public function getServiceType()
    {
        return 'wms';
        // and also wfs
    }

    static public function needLayer() 
    {
        return true;
    }

    static public function getMandatoryResourceOptionList()
    {
        return array("filterable");
    }

    /**
    * Return the WFS DescribeFeatureType response text of a resource using its
    * WFS service.
    * 
    * @param string $pstrResourceName The name of the resource
    * 
    * @return string
    */
    static public function getWFSDescribeFeatureType($pstrResourceName)
    {
        $objConfig = org_geoprisma_config_ConfigFactory::getConfig();
        $objResource = $objConfig->getResource($pstrResourceName);
        return $objResource->getWFSDescribeFeatureType();
    }

    /**
    * Return the WMS GetStyles response text of a resource using its WMS
    * service.
    * 
    * @param string $pstrResourceName The name of the resource
    * 
    * @return string
    */
    static public function getWMSStyles($pstrResourceName)
    {
        $objConfig = org_geoprisma_config_ConfigFactory::getConfig();
        $objResource = $objConfig->getResource($pstrResourceName);
        return $objResource->getWMSStyles();
    }
}
  
?>
