<?xml version="1.0" encoding="utf-8"?>
<!-- 
   Copyright (c) 2011- Solution Globale, published under the BSD license.
   See http://geoprisma.org/license for the full text of the license. 
 --> 
<xsl:stylesheet version="1.0" xmlns:php="http://php.net/xsl"
    xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
    xmlns:dyn="http://exslt.org/dynamic"
    xmlns:keepactivesession="http://geoprisma.org/keepactivesession"
    extension-element-prefixes="dyn">

  <xsl:output method="html" indent="yes" encoding="utf-8" omit-xml-declaration="yes"/>
  <xsl:namespace-alias stylesheet-prefix="php" result-prefix="xsl" />

  <!-- printWidgetSource START  -->
  <xsl:template name="keepactivesession:printWidgetSource">
    <xsl:variable name="WidgetType">
      <xsl:text>keepactivesession</xsl:text>
    </xsl:variable>
    <script>
        <xsl:attribute name="src" >
             <xsl:value-of select="$g_widgets_url"/>
             <xsl:text>/keepactivesession/lib/org.GeoPrisma.KeepActiveSession.js</xsl:text>
        </xsl:attribute>    
    </script>

   </xsl:template>
  <!-- printWidgetSource END  -->

  <!-- printWidgetExecution START  -->
  <xsl:template name="keepactivesession:printWidgetExecution">
    <xsl:param name="pWidgetName" />
    <xsl:param name="pMapName" />
    <xsl:variable name="WidgetType">
      <xsl:text>keepactivesession</xsl:text>
    </xsl:variable>
    
    <script type="text/javascript">
      oMap = objGPWidget<xsl:value-of select="$pMapName"/>;

      var objWidgetOptions = {};
      <xsl:for-each select="./options">
        objWidgetOptions =
        <xsl:call-template name="getObjectFromNode">
          <xsl:with-param name="pNode" select="." />
        </xsl:call-template>;
      </xsl:for-each>
      objWidgetOptions['map'] = oMap;
      
      objWidgetOptions['url'] = "<xsl:value-of select="$proxyurl" />"; 
      
      var objGPWidget<xsl:value-of select="$pWidgetName" /> =
          new org.GeoPrisma.KeepActiveSession(objWidgetOptions);
    </script>
  </xsl:template>
  <!-- printWidgetExecution END  -->

</xsl:stylesheet>