<?php
/* 
   Copyright (c) 2009- Boreal - Information Strategies, published under the BSD license.
   See http://geoprisma.org/license for the full text of the license. 
*/ 
  
class MapFishLayerTree extends org_geoprisma_widget_WidgetBase
{
    static public function getText($pstrMsg, $pstrType = null, $pstrDomain = null)
    {
        if ($pstrDomain == null) 
        {
            $pstrDomain = self::getType();      
        }
        return parent::getText($pstrMsg, $pstrDomain, $pstrType);
    }
     
    static public function getAction()
    {
        return 'read';
    }    
     
    static public function getType()
    {
        return 'mapfishlayertree';
    }

    static public function getServiceType()
    {
        return null;
    }

    static public function getMandatoryResourceOptionList()
    {
        return array("layertreepath");
    }

    static public function getOptionalResourceOptionList()
    {
        return null;

        // not really used by the code, is more or less used as a reference list
        // here's a complete list of resource options usable by this widget :

        /*
        $objArrayoptions = array(
            "layertreepathwms",
            "layertreepathtilecache",
            "layertreepathfeatureserver",
            "layertreepathgymo",
            "layertreepathmapserver",
            "visibility",
            "visibilitywms",
            "visibilitytilecache",
            "visibilityfeatureserver",
            "visibilitygymo",
            "visibilitymapserver",
            "minscaledenom",
            "minscaledenomwms",
            "minscaledenomtilecache",
            "minscaledenomfeatureserver",
            "minscaledenomgymo",
            "minscaledenommapserver",
            "maxscaledenom",
            "maxscaledenomwms",
            "maxscaledenomtilecache",
            "maxscaledenomfeatureserver",
            "maxscaledenomgymo",
            "maxscaledenommapserver"
        );
        */
    }

    static public function mustClone()
    {
        return false;
    }

    static public function linkResource($pobjResource, $pobjWidget) 
    {
        if ($pobjResource == null || $pobjWidget == null) 
        {
            return;
        }

        $bServicePaths = false;

        // required & other options
        $strLayerTreePathOption = "layertreepath";
        $objArrayOtherOptions = array(
            "visibility", "minscaledenom", "maxscaledenom"
        );

        foreach ($pobjResource->getDatastores() as $objDatastore) 
        {
            $strLayerTreePath = null;
            $objArrayLayerNodeOptions = array();

            // get servicetype
            $strServiceType = $objDatastore->getService()->getType();

            // get layertreepath
            $objOption = $pobjResource->getOption(
                $strLayerTreePathOption.$strServiceType, true
            );
            if ($objOption) 
            {
                $strLayerTreePath = $objOption->getValue();
            }
            else
            {
                $strLayerTreePath = $pobjResource->getOption(
                    $strLayerTreePathOption, true
                )->getValue();
            }

            // get other options
            foreach ($objArrayOtherOptions as $strOtherOption) 
            {
                $strOption = null;

                $objOption = $pobjResource->getOption(
                    $strOtherOption.$strServiceType, true
                );
                if ($objOption) 
                {
                    $strOption = $objOption->getValue();
                }
                else
                {
                    $objOption = $pobjResource->getOption(
                        $strOtherOption, true
                    );

                    if ($objOption) 
                    {
                        $strOption = $objOption->getValue();
                    }
                }

                switch ($strOtherOption)
                {
                    case "visibility":
                        switch ($strOption) 
                        {
                            case "yes":
                            case "true":
                                $objArrayLayerNodeOptions['checked'] = 'true';
                                break;
                            case "no":
                            case "false":
                                $objArrayLayerNodeOptions['checked'] = 'false';
                                break;
                            default:
                                $objArrayLayerNodeOptions['checked'] = 'true';
                                break;
                        }
                        break;

                    case "minscaledenom":
                        if ($strOption) 
                        {
                            $objArrayLayerNodeOptions['minScale'] = $strOption;
                        }
                        break;

                    case "maxscaledenom":
                        if ($strOption) 
                        {
                            $objArrayLayerNodeOptions['maxScale'] = $strOption;
                        }
                        break;
                }
            }

            $pobjWidget->addLayerNodeFromPath(
                $strLayerTreePath,
                $pobjResource,
                $strServiceType,
                $objArrayLayerNodeOptions
            );
        }
    }
}
  
?>
