<?php
/* 
   Copyright (c) 2009- Boreal - Information Strategies, published under the BSD license.
   See http://geoprisma.org/license for the full text of the license. 
*/ 

class MapFishRecenter extends org_geoprisma_widget_WidgetBase
{

    static public function getText($pstrMsg, $pstrType = null, $pstrDomain = null)
    {
        if ($pstrDomain == null)
        {
            $pstrDomain = self::getType();      
        }
        return parent::getText($pstrMsg, $pstrDomain, $pstrType);
    }
     
    static public function getAction()
    {
        return 'read';
    }    
     
    static public function getType()
    {
        return 'mapfishrecenter';
    }

    static public function getServiceType()
    {
        return 'featureserver';
    }

    static public function getMandatoryResourceOptionList()
    {
        return array("field" => "zoomField");
    }

    static public function getOptionalResourceOptionList()
    {
        return null;
    }

    static public function mustClone()
    {
        return true;
    }

    static public function linkResource($pobjResource, $pobjWidget) 
    {
        if ($pobjResource == null || $pobjWidget == null) 
        {
            return;
        }

        $objArrayFieldNodes = array();

        try
        {
            $objArrayZoomFields 
                = array($pobjResource->getOption('zoomField')->getValue());
        }
        catch(Exception $objError)
        {
            $objArrayZoomFields 
                = $pobjResource->getOption('zoomFields')->getValue();
        }

        foreach($objArrayZoomFields as $strZoomField) 
        {
            $objArrayFieldNode = array(
                'queryparam' => $strZoomField,
                'displayfield' => $strZoomField
            );

            // if a similar resource field exists, then see if it has more
            // options as well
            try
            {
                $objField = $pobjResource->getField($strZoomField, 'name');
                $objArrayFieldNode['label'] = $objField->getTitle();

                try
                {
                    $objArrayFieldNode['filter'] 
                        = $objField->getOption('filter')->getValue();
                }
                catch(Exception $objError)
                {
                }
            }
            catch(Exception $objError)
            {
                $objArrayFieldNode['label'] = $strZoomField;
            }

            array_push($objArrayFieldNodes, $objArrayFieldNode);
        }

        $pobjWidget->addOrReplaceOption(
            new org_geoprisma_option_Option('fields', $objArrayFieldNodes)
        );
    }
}
  
?>
