<?xml version="1.0" encoding="utf-8"?>
<!--
   Copyright (c) 2011- Mapgears Inc., published under the BSD license.
   See http://geoprisma.org/license for the full text of the license.
 -->

<xsl:stylesheet version="1.0" xmlns:php="http://php.net/xsl"
    xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
    xmlns:dyn="http://exslt.org/dynamic"
    xmlns:resultvectorlayer="http://geoprisma.org/resultvectorlayer"
    extension-element-prefixes="dyn">
  <xsl:namespace-alias stylesheet-prefix="php" result-prefix="xsl" />

  <xsl:template name="resultvectorlayer:printWidgetSource">
    <script>
      <xsl:attribute name="src" >
        <xsl:value-of select="$g_widgets_url"/>
        <xsl:text>/resultvectorlayer/ResultVectorLayer.js</xsl:text>
      </xsl:attribute>    
    </script>
  </xsl:template>

  <xsl:template name="resultvectorlayer:printWidgetExecution">
    <xsl:param name="pWidgetName" />
    <xsl:param name="pMapName" />

    <script type="text/javascript">
      var objWidgetOptions = <xsl:for-each select="./options"><xsl:call-template name="getObjectFromNode"><xsl:with-param name="pNode" select="." /></xsl:call-template></xsl:for-each>;

      objWidgetOptions.map = objGPWidget<xsl:value-of select="$pMapName" />;

      objWidgetOptions.resources = [];
      <xsl:for-each select="./resources/resource">objWidgetOptions.resources.push('<xsl:value-of select="." />');
      </xsl:for-each>

      <!-- Bind 'vectorlayer' widget START -->
      <xsl:if test="./options/vectorlayer">
        <xsl:variable name="vectorLayer">
          <xsl:value-of select="./options/vectorlayer" />
        </xsl:variable>
        <xsl:if test="//geoprisma/widgets/widget[./name = $vectorLayer]">objWidgetOptions.layer = window.objGPWidget<xsl:value-of select="$vectorLayer" /> || false;</xsl:if>
      </xsl:if>
      <!-- Bind 'vectorlayer' widget END -->

      objGPWidget<xsl:value-of select="$pWidgetName" /> = new OpenLayers.ResultVectorLayer(objWidgetOptions);

      <!-- Bind this widget to all widgets refering to it in an option START -->
      <xsl:for-each select="//options/results[./result = $pWidgetName]">
        <xsl:for-each select="../../name">
          <xsl:variable name="queryWidgetName">
            <xsl:value-of select="." />
          </xsl:variable>
          
          objGPWidget<xsl:value-of select="$queryWidgetName" />.addResult(objGPWidget<xsl:value-of select="$pWidgetName" />);
          objGPWidget<xsl:value-of select="$pWidgetName" />.setQuery(objGPWidget<xsl:value-of select="$queryWidgetName" />);
        </xsl:for-each>
      </xsl:for-each>

      <xsl:for-each select="//options[./result = $pWidgetName]">
        <xsl:for-each select="../name">
          <xsl:variable name="queryWidgetName">
            <xsl:value-of select="." />
          </xsl:variable>

          objGPWidget<xsl:value-of select="$queryWidgetName" />.addResult(objGPWidget<xsl:value-of select="$pWidgetName" />);
          objGPWidget<xsl:value-of select="$pWidgetName" />.setQuery(objGPWidget<xsl:value-of select="$queryWidgetName" />);
        </xsl:for-each>
      </xsl:for-each>
      <!-- Bind this widget to all widgets refering to it in an option END -->
    </script>
  </xsl:template>
</xsl:stylesheet>
