<?xml version="1.0" encoding="utf-8"?>
<!-- 
   Copyright (c) 2011- Mapgears Inc., published under the BSD license.
   See http://geoprisma.org/license for the full text of the license.
 --> 

<xsl:stylesheet version="1.0" xmlns:php="http://php.net/xsl"
    xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
    xmlns:dyn="http://exslt.org/dynamic"
    xmlns:vectorlayer="http://geoprisma.org/vectorlayer"
    extension-element-prefixes="dyn">
  <xsl:namespace-alias stylesheet-prefix="php" result-prefix="xsl" />

  <xsl:template name="vectorlayer:printWidgetSource">
    <xsl:variable name="WidgetType">
      <xsl:text>vectorlayer</xsl:text>
    </xsl:variable>
  </xsl:template>

  <xsl:template name="vectorlayer:printWidgetExecution">
    <xsl:param name="pWidgetName" />
    <xsl:param name="pMapName" />

    <xsl:variable name="WidgetType">
      <xsl:text>vectorlayer</xsl:text>
    </xsl:variable>

    <script type="text/javascript">
      <xsl:call-template name="getOpenLayersOptions" ><xsl:with-param name="pWidgetName"><xsl:value-of select="$pWidgetName" /></xsl:with-param></xsl:call-template>
      objGPWidget<xsl:value-of select="$pWidgetName" /> = new OpenLayers.Layer.Vector('<xsl:choose><xsl:when test="./options/title"><xsl:value-of select="./options/title" /></xsl:when><xsl:otherwise><xsl:value-of select="$pWidgetName" /></xsl:otherwise></xsl:choose>', objOptions);

      objGPWidget<xsl:value-of select="$pMapName" />.addLayer(objGPWidget<xsl:value-of select="$pWidgetName" />);

      <!-- move vector layer to top after "printallwidgetexecutions" -->
      objGPWidget<xsl:value-of select="$pMapName" />.events.on({
          "printallwidgetexecutions": function(event) {
              this.map.setLayerIndex(this.layer, this.map.layers.length)
          }, scope: {
              layer: objGPWidget<xsl:value-of select="$pWidgetName" />,
              map: objGPWidget<xsl:value-of select="$pMapName" />
          }
      });
    </script>
  </xsl:template>

</xsl:stylesheet>
