<?php
/**
* Factory pour la config
*
* PHP versions 5
* 
* @category  PHP
* @package   GeoPrisma  
* @author    Pascal Martin 
* @copyright 2009, Boreal - Information Strategies
* @license   http://www.geoprisma.org/license BSD License
* @link      http://www.geoprisma.org
*/
    
/**
* Factory pour la config
* 
* @category   PHP 
* @package    GeoPrisma
* @subpackage Config
* @author     Pascal Martin
*/
class org_geoprisma_config_ConfigFactory extends com_borealis_foundation_manager_Factory
{
    /**
    * Construit une nouvelle instance de org_geoprisma_config_ConfigFactory
    * Force l'utilisation de la méthode getConfig 
    * 
    * @return org_geoprisma_config_ConfigFactory
    */
    private function __construct() 
    {
        // vide
    }
    
    /**
    * Return a Config
    * 
    * @return org_geoprisma_config_Config
    */
    public static function getConfig()
    {
          /*
          if(!isset($_SESSION["gpConfig"]))
          {
           $objConfigFactory = new org_opensafemap_config_ConfigFactory();
           $_SESSION["gpConfig"] = serialize($objConfigFactory->getManager(org_opensafemap_SettingImpl::getConfig()));  
          }
          
                return unserialize($_SESSION["gpConfig"]);
          */
    
        $objConfigFactory = new org_geoprisma_config_ConfigFactory(); 
        return $objConfigFactory->getManager(org_geoprisma_SettingImpl::getConfig());
    }
    
    /**
    * Vérifie que l'object passer est un instance de org_geoprisma_config_Config
    * 
    * @param object $pobjManager object to test
    * 
    * @return bool
    */            
    protected function isGoodInstance($pobjManager)
    {
        return $pobjManager instanceof org_geoprisma_config_Config;  
    }
    
    /**
    * Retourne une erreur
    * 
    * @param string $pstrMessage Message erreur
    * 
    * @return org_geoprisma_exception_BadConfigException
    */
    protected function getError($pstrMessage)
    {
        return new org_geoprisma_exception_BadConfigException($pstrMessage);   
    }  
}
    
    
?>