<?php
/**
* Constructs the MapFishPrintProxy instance according to the type of request
*
* PHP versions 5
* 
* @category  PHP
* @package   GeoPrisma  
* @author    Alexandre Dube
* @copyright 2011, Boreal - Information Strategies
* @license   http://www.geoprisma.org/license BSD License
* @link      http://www.geoprisma.org
*/

/**
* MapFishPrint proxy factory
* 
* @category   PHP 
* @package    GeoPrisma
* @subpackage Proxy 
* @author     Alexandre Dube
*/  
class org_geoprisma_proxy_mapfishprint_MapFishPrintProxyFactory
{
    /**
    * Returns the right kind of mapfish print proxy
    * 
    * @param org_geoprisma_service_MapFishPrintService $pobjService Service
    * 
    * @return org_geoprisma_proxy_wfs_MapFishPrintProxy
    */
    public static function getMapFishPrintProxy(org_geoprisma_service_MapFishPrintService $pobjService)
    {        
        if (!isset($_REQUEST))
        {
            $objProxy = null;
        }
        else if (isset($_REQUEST['osmfile']))
        {
            $objProxy = new org_geoprisma_proxy_mapfishprint_MapFishPrintGetFileProxy($pobjService);
        }
        else
        {
            $objProxy = new org_geoprisma_proxy_mapfishprint_MapFishPrintProxy($pobjService);
        }

        if ($objProxy == null)
        {
            throw new com_borealis_foundation_exception_AssertException("Proxy method not handled.");
        }

        return $objProxy;
    }    
}
?>
