<?php
/**
* WFS Proxy for getCapabilities requests
*
* PHP versions 5
* 
* @category  PHP
* @package   GeoPrisma  
* @author    Etienne Dube
* @copyright 2011, Boreal - Information Strategies
* @license   http://www.geoprisma.org/license BSD License
* @link      http://www.geoprisma.org
*/

/**
* WFS Proxy for getCapabilities requests
* 
* @category   PHP 
* @package    GeoPrisma
* @subpackage Proxy 
* @author     Etienne Dube 
*/ 
class org_geoprisma_proxy_wfs_WFSGetCapabilityProxy extends org_geoprisma_proxy_wfs_WFSProxy
{
    /**
    * Foward the call end return the result
    * 
    * @return void
    */
    public function process()
    {
        $objCurl = curl_init($this->addParam($this->getService()->getSource()));                 
        curl_exec($objCurl);
        curl_close($objCurl); 
    }
    
    /**
    * Returns the name of the action done by this proxy (Create / Read / Update / Delete)
    *                                   
    * @return string
    */
    public function getAction()
    {
        return self::CRUD_READ;    
    }
}

?>
