<?php
/**
* TMS Service type
*
* PHP versions 5
* 
* @category  PHP
* @package   GeoPrisma  
* @author    Alexandre Dube 
* @copyright 2009-2011, Mapgears Inc.
* @license   http://www.geoprisma.org/license BSD License
* @link      http://www.geoprisma.org
*/

/**
* TMS Service type
* 
* @category   PHP 
* @package    GeoPrisma
* @subpackage Service 
* @author     Alexandre Dube
*/   
class org_geoprisma_service_TMSService extends org_geoprisma_service_Service
{
    const TILECACHE_SERVICE = 'tms';
    const TYPE = 'tms';
    const TYPE_ID = 12;
    
    private $m_strFormat = null;
    private $m_strSRS = null;
    
    /**
    * Creates a new org_geoprisma_service_TMSService instance
    * 
    * @param array $pobjArray Config array
    * 
    * @return org_geoprisma_service_TMSService
    */
    public function __construct($pobjArray) 
    {
        if (isset($pobjArray['id'])) 
        {
            $strName = (string)$pobjArray['id'];
        }
        else
        {
            $strName = (string)$pobjArray['name'];
        }

        $strSource = (string)$pobjArray['source'];

        parent::__construct($strName, $strSource, self::TYPE, $pobjArray);
    }

    /**
    * Return the OpenLayers.Layer default options using this type of service.
    * 
    * @param org_geoprisma_config_Config &$pobjConfig Config object
    *
    * @return array 
    */
    public function getDefaultLayerOptions(&$pobjConfig)
    {
        return array();
    }
    
    /**
    *  Add this service to XML
    * 
    * @param DOMElement  &$pobjDomElementServices
    * @param DOMDocument &$pobjDomDocument
    * 
    * @return void
    */
    public function insertIntoXML(
        DOMElement &$pobjDomElementServices,
        DOMDocument &$pobjDomDocument
    ) {
        // create service node with 'type', 'name' and 'options' nodes
        $objDomElementService = $pobjDomDocument->createElement('service');
        $objDomElementService->appendChild($pobjDomDocument->createElement(
            'type',
            self::TILECACHE_SERVICE
        ));
        $objDomElementService->appendChild($pobjDomDocument->createElement(
            'name',
            $this->getName()
        )); 
        $objDomElementService->appendChild(
            $this->getDomElements(
                'options', $this->getOptions(), $pobjDomDocument
            )
        );
        // add service node to services node
        $pobjDomElementServices->appendChild($objDomElementService);
    }
}
  
?>
