<?php
    
class org_geoprisma_config_XMLWorkspaceConfigTest extends PHPUnit_Framework_TestCase
{
    public function testGetInstance()    
    {
        $objConfig = org_geoprisma_config_XMLWorkspaceConfig::getInstance();
        $this->assertTrue($objConfig instanceof org_geoprisma_config_XMLWorkspaceConfig);
        $this->assertTrue($objConfig instanceof org_geoprisma_config_XMLConfig);
        $this->assertTrue($objConfig instanceof org_geoprisma_config_Config);
        $this->assertTrue($objConfig instanceof com_borealis_foundation_util_Singleton);    
    }  
      
    public function testSetCurrentWorkspace()    
    {
        $this->assertEquals('', org_geoprisma_config_XMLWorkspaceConfig::getCurrentWorkspace()); 
        org_geoprisma_config_XMLWorkspaceConfig::setCurrentWorkspace('test1');
        $this->assertEquals('test1', org_geoprisma_config_XMLWorkspaceConfig::getCurrentWorkspace());
        org_geoprisma_config_XMLWorkspaceConfig::setCurrentWorkspace('');    
        $this->assertEquals('', org_geoprisma_config_XMLWorkspaceConfig::getCurrentWorkspace());
    }
    
    // Vérifie le nombre de resource
    public function testLoadResource()    
    {
        $objConfig = org_geoprisma_config_XMLWorkspaceConfig::getInstance();
        $this->assertEquals(0, $objConfig->getResources()->count()); 
        org_geoprisma_config_XMLWorkspaceConfig::setCurrentWorkspace('workspace1');
        $objConfig->reload();
        $this->assertEquals(2, $objConfig->getResources()->count());         
    }
    
    // Vérifie l'overload des option des ressources par le worspace
    public function testLoadResource2()    
    {
        $objConfig = org_geoprisma_config_XMLWorkspaceConfig::getInstance(); 
        org_geoprisma_config_XMLWorkspaceConfig::setCurrentWorkspace('workspace1');
        $objConfig->reload();
        $this->assertEquals(2, $objConfig->getResources()->count());
        
        $objResource =  $objConfig->getResource('ResourceVMap0');
        
        $this->assertEquals(3, $objResource->getOptions()->count());
        $this->assertEquals('<option1>value1</option1>', $objResource->getOption('option1')->getValue());
        $this->assertEquals('<option2>value2</option2>', $objResource->getOption('option2')->getValue());
        $this->assertEquals('<option3>value3</option3>', $objResource->getOption('option3')->getValue());             
    }
    
    // Vérifie le chargement des widget dans la resources
    public function testLoadResource3()    
    {
        $objConfig = org_geoprisma_config_XMLWorkspaceConfig::getInstance(); 
        org_geoprisma_config_XMLWorkspaceConfig::setCurrentWorkspace('workspace1');
        $objConfig->reload();
        
        
        $objResource =  $objConfig->getResource('ResourceVMap0');
        $this->assertEquals(0, $objResource->getWidgets()->count()); 
        
        $objResource =  $objConfig->getResource('ResourceScribble');
        $this->assertEquals(3, $objResource->getWidgets()->count());
    }
    
    // Vérifie l'overload des options de widget et le rename du widget
    public function testLoadResource4()    
    {
        $objConfig = org_geoprisma_config_XMLWorkspaceConfig::getInstance(); 
        org_geoprisma_config_XMLWorkspaceConfig::setCurrentWorkspace('workspace1');
        $objConfig->reload();
        
        $objWidget1 = $objConfig->getWidget('QuickZoomDemo');
        $this->assertEquals('<field>title</field>', $objWidget1->getOption('field')->getValue());    
        $this->assertEquals('<buffer>12%</buffer>', $objWidget1->getOption('buffer')->getValue());
        
        $objResource = $objConfig->getResource('ResourceScribble');
        $objWidget2 = $objResource->getWidgets()->offsetGet(2); 
        $this->assertEquals('QuickZoomDemo_ResourceScribble', $objWidget2->getName());
        
        $this->assertEquals('<field>title</field>', $objWidget2->getOption('field')->getValue());    
        $this->assertEquals('<buffer>15%</buffer>', $objWidget2->getOption('buffer')->getValue());
    }
   
    protected function setUp()    
    {  
        $GLOBALS['XMLConfigFile'] = org_geoprisma_SettingImpl::getXMLConfigFile(); 
        org_geoprisma_SettingImpl::setConfig('org_geoprisma_config_XMLWorkspaceConfig');
        org_geoprisma_config_XMLWorkspaceConfig::setCurrentWorkspace('');
        $objConfig = org_geoprisma_config_XMLWorkspaceConfig::getInstance();
        $objConfig->reload();       
    }
   
    protected function tearDown()    
    {  
        org_geoprisma_SettingImpl::setXMLConfigFile($GLOBALS['XMLConfigFile']); 
        org_geoprisma_SettingImpl::setConfig('org_geoprisma_config_XMLConfig'); 
        $objConfig = org_geoprisma_config_XMLConfig::getInstance();
        $objConfig->reload();       
    }
}
  
?>