<?php
    
class org_geoprisma_proxy_ProxyFactoryTest extends PHPUnit_Framework_TestCase
{
    
    /**
    * @expectedException Exception 
    */
    public function testGetProxy()    
    {
        org_geoprisma_proxy_ProxyFactory::getProxy();
    }
    
    public function testGetProxy2()    
    {
        $_REQUEST['osmservice'] = 'FeatureServerDemo';   
        $_REQUEST['osmresource'] = 'ResourceScribble'; 
        $objProxy = org_geoprisma_proxy_ProxyFactory::getProxy();
        $this->assertTrue($objProxy instanceof org_geoprisma_proxy_Proxy); 
        $this->assertTrue($objProxy instanceof org_geoprisma_proxy_featureserver_FeatureServerProxy);        
    }
       
    public function testGetProxy3()    
    {
        $_REQUEST['osmservice'] = 'MetaCartaVM0';   
        $_REQUEST['osmresource'] = 'ResourceVMap0'; 
        $objProxy = org_geoprisma_proxy_ProxyFactory::getProxy();
        $this->assertTrue($objProxy instanceof org_geoprisma_proxy_Proxy);
        $this->assertTrue($objProxy instanceof org_geoprisma_proxy_wms_WMSProxy);
    }
    

    /**
    * @expectedException org_geoprisma_exception_ServiceNotFoundException 
    */
    public function testGetProxy4()    
    {
        $_REQUEST['osmservice'] = 'sfsfgidsnjfug';   
        $_REQUEST['osmresource'] = 'ResourceVMap0'; 
        org_geoprisma_proxy_ProxyFactory::getProxy();
    }
    
    /**
    * @expectedException Exception 
    */
    public function testGetProxy5()    
    {
        $_REQUEST['osmservice'] = 'MetaCartaVM0';   
        org_geoprisma_proxy_ProxyFactory::getProxy();
    }
    
    /**
    * @expectedException org_geoprisma_exception_ResourceNotFoundException 
    */
    public function testGetProxy6()    
    {
        $_REQUEST['osmservice'] = 'MetaCartaVM0';
        $_REQUEST['osmresource'] = 'sasdfgs'; 
        org_geoprisma_proxy_ProxyFactory::getProxy(); 
      
    }
    
    /**
    * @expectedException Exception 
    */
    public function testGetProxy7()    
    {
        $_REQUEST['osmservice'] = 'FeatureServerDemo';   
        $_REQUEST['osmresource'] = 'ResourceVMap0'; 
        org_geoprisma_proxy_ProxyFactory::getProxy();
    }
    
    /**
    * @expectedException Exception 
    */
    public function testGetProxy8()    
    {
        org_geoprisma_SettingImpl::setACLClass('org_geoprisma_acl_BorealisACL'); 
        org_geoprisma_acl_BorealisACL::setUsername('bidon');
        $objConfig = org_geoprisma_config_ConfigFactory::getConfig(); 
        $objConfig->reload(); 
        
        $_REQUEST['osmservice'] = 'MetaCartaVM0';   
        $_REQUEST['osmresource'] = 'ResourceVMap0'; 
        org_geoprisma_proxy_ProxyFactory::getProxy();    
    }
    
    public function testGetProxy9()    
    {
        $_REQUEST['osmservice'] = 'MetaCartaVM0';   
        $_REQUEST['osmresource'] = array('ResourceVMap0', 'ResourceVMap0'); 
        $objProxy = org_geoprisma_proxy_ProxyFactory::getProxy();
        $this->assertTrue($objProxy instanceof org_geoprisma_proxy_Proxy);
        $this->assertTrue($objProxy instanceof org_geoprisma_proxy_wms_WMSProxy);
    } 
    
    public function testGetProxy10()    
    {
        org_geoprisma_SettingImpl::setACLClass('org_geoprisma_acl_BorealisACL'); 
        org_geoprisma_acl_BorealisACL::setUsername('pmartin');
        $objConfig = org_geoprisma_config_ConfigFactory::getConfig(); 
        $objConfig->reload(); 
        
        $_REQUEST['osmservice'] = 'MetaCartaVM0';   
        $_REQUEST['osmresource'] = 'ResourceVMap0'; 

        org_geoprisma_proxy_ProxyFactory::getProxy();    
    }
    
    /**
    * Exception: Not Authorized by Datastore layer
    * 
    * @expectedException Exception 
    */
    public function testGetProxy11()    
    {
        $_REQUEST['osmservice'] = 'FeatureServerDemo';
        $_REQUEST['osmresource'] = 'ResourceScribble';
        $_SERVER['PATH_INFO'] = '/scribble258/2.json';  
        $objProxy = org_geoprisma_proxy_ProxyFactory::getProxy();
        $this->assertTrue($objProxy instanceof org_geoprisma_proxy_Proxy);
        $this->assertTrue($objProxy instanceof org_geoprisma_proxy_featureserver_FeatureServerProxy);   
        $this->assertTrue($objProxy instanceof org_geoprisma_proxy_featureserver_FeatureServerReadProxy);
    }
    
    public function setUp()
    {
        $GLOBALS['PHPUNIT_ACLClass'] = org_geoprisma_SettingImpl::getACLClass();
    }
    
    public function tearDown()
    {
        org_geoprisma_SettingImpl::setACLClass($GLOBALS['PHPUNIT_ACLClass']);  
        
        $objConfig = org_geoprisma_config_ConfigFactory::getConfig(); 
        $objConfig->reload();
    } 
}
  
?>