<?php
    
class org_geoprisma_proxy_featureserver_FeatureServerReadProxyTest extends PHPUnit_Framework_TestCase
{
    
    public function testProcess()    
    {
        $_REQUEST['osmservice'] = 'FeatureServerDemo';
        $_REQUEST['osmresource'] = 'ResourceScribble'; 
        $_SERVER['PATH_INFO'] = '/scribble/all.json';   
        $objProxy = org_geoprisma_proxy_ProxyFactory::getProxy();
        $this->assertTrue($objProxy instanceof org_geoprisma_proxy_Proxy); 
        $this->assertTrue($objProxy instanceof org_geoprisma_proxy_featureserver_FeatureServerProxy);        
        $this->assertTrue($objProxy instanceof org_geoprisma_proxy_featureserver_FeatureServerReadProxy);        
        
        ob_start();
        $objProxy->process();    
        $strJsonResult = ob_get_contents();
        ob_end_clean();
        
        $objResult = json_decode($strJsonResult); 
        $this->assertTrue(count($objResult->features) > 0);                  
    }
    
    public function testProcess2()    
    {
        $_REQUEST['osmservice'] = 'FeatureServerDemo';
        $_REQUEST['osmresource'] = 'ResourceScribble'; 
        $_SERVER['PATH_INFO'] = '/scribble/all.gml';   
        $objProxy = org_geoprisma_proxy_ProxyFactory::getProxy();
        $this->assertTrue($objProxy instanceof org_geoprisma_proxy_Proxy); 
        $this->assertTrue($objProxy instanceof org_geoprisma_proxy_featureserver_FeatureServerProxy);        
        $this->assertTrue($objProxy instanceof org_geoprisma_proxy_featureserver_FeatureServerReadProxy);        
        
        ob_start();
        $objProxy->process();    
        $strXMLResult = ob_get_contents();
        ob_end_clean();

        $this->assertTrue(strstr($strXMLResult, '<gml:coordinates>') !== false);
    }
    
    public function testProcess3()    
    {
        $_REQUEST['osmservice'] = 'FeatureServerOSM';
        $_REQUEST['osmresource'] = 'ResourceScribbleOSM'; 
        $_SERVER['PATH_INFO'] = '/scribble/all.json';
        $_SERVER['REQUEST_METHOD'] = 'GET';        
        $objProxy = org_geoprisma_proxy_ProxyFactory::getProxy();
        $this->assertTrue($objProxy instanceof org_geoprisma_proxy_Proxy); 
        $this->assertTrue($objProxy instanceof org_geoprisma_proxy_featureserver_FeatureServerProxy);        
        $this->assertTrue($objProxy instanceof org_geoprisma_proxy_featureserver_FeatureServerReadProxy);        
        ob_start();
        $objProxy->process();    
        $strJsonResult = ob_get_contents();
        ob_end_clean();
    }
}
  
?>